// DaaView.h : interface of the CDaaView class
//
/////////////////////////////////////////////////////////////////////////////

class CDaaView : public CView
{
protected: // create from serialization only
	CDaaView();
	DECLARE_DYNCREATE(CDaaView)

// Attributes
public:
	CDaaDoc* GetDocument();



// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDaaView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDaaView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDaaView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnTestStopdraw();
	afx_msg void OnTestViewsamples();
	afx_msg void OnUpdateTestViewsamples(CCmdUI* pCmdUI);
	afx_msg void OnUpdateTestStopdraw(CCmdUI* pCmdUI);
	afx_msg void OnBwMax();
	afx_msg void OnBw30();
	afx_msg void OnBw10();
	afx_msg void OnBw3();
	afx_msg void OnBw1();
	afx_msg void OnUpdateBwMax(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBw30(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBw10(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBw3(CCmdUI* pCmdUI);
	afx_msg void OnUpdateBw1(CCmdUI* pCmdUI);
	afx_msg void OnOpenMixers();
	afx_msg void OnOpenAudioDevices();
	afx_msg void OnTestSpectrum3d();
	afx_msg void OnUpdateTestSpectrum3d(CCmdUI* pCmdUI);
	afx_msg void OnViewSetreference();
	afx_msg void OnUpdateViewSetreference(CCmdUI* pCmdUI);
	afx_msg void OnHelpHelp();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnUpdateTestMultidraw(CCmdUI* pCmdUI);
	afx_msg void OnTestMultidraw();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DaaView.cpp
inline CDaaDoc* CDaaView::GetDocument()
   { return (CDaaDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
