
#ifndef INC_DRAWUTILS
#define INC_DRAWUTILS


//#include "stdafx.h"
//
//// DrawUtil-SPECIFIC
#include "math.h"
////#include "dos.h"
////#include "conio.h"
//
//
//long			g_Width;
//long			g_Height;
//long			g_WidthBytes;
//long			g_BitsPixel;
//void*			g_Bits = 0;
//HDC			g_hdc;
//HBITMAP		g_oldBmp;
//HBITMAP		g_Bmp = 0;
//BITMAPINFO*	g_pBitmapInfo = 0;
//
//
//
/////////////////////////////////////////////////////////////////////////////////////
////  CREAZIONE, DISTRUZIONE e VISUALIZZAZIONE
/////////////////////////////////////////////////////////////////////////////////////
//
//
//void BMP_Show (HDC hdcOut)
//{
//	if (g_Bits == 0) return;
//
// 	
//	SetDIBitsToDevice(
//						hdcOut,
//						0,
//						0,
//						g_pBitmapInfo->bmiHeader.biWidth,
//						g_pBitmapInfo->bmiHeader.biHeight,
//						0,
//						0,
//						0,
//						g_pBitmapInfo->bmiHeader.biHeight,
//						g_Bits,
//						g_pBitmapInfo,
//						DIB_RGB_COLORS
//					);
//	
//}
//
//
//
//
//void BMP_End()
//{
//	SelectObject(g_hdc, g_oldBmp);
//	DeleteDC(g_hdc);
//	
//
//	//delete [] g_pBitmapInfo;			// <-- heap corruption ( only in debug )
//	//delete [] (BYTE*) g_pBitmapInfo;	// <-- heap corruption ( only in debug )
//	delete g_pBitmapInfo;				// <-- OK
//
//
//	DeleteObject(g_Bmp);
//	
//	g_Bits = 0;
//	g_pBitmapInfo = 0;
//}
//
//
//void BMP_InitFromHDC(HDC hDC)
//{
//
//	// Se era gia stata creata una bitmap la disalloco prima di farne un' altra.
//	if (g_pBitmapInfo != 0) BMP_End();
//
//	CDC* pDC = pDC->FromHandle(hDC);
//
//	// ---------------------------------------------------------------
//	CBitmap* pBmp = pDC->GetCurrentBitmap();
//
//	// --------------------------------------------------------------- recupero le informazioni
//	BITMAP bmp;
//	pBmp->GetBitmap(&bmp); 
//	g_Width = bmp.bmWidth;
//	g_Height = bmp.bmHeight;
//	g_WidthBytes = bmp.bmWidthBytes;
//	g_BitsPixel = bmp.bmBitsPixel;
//	DeleteObject(&bmp);
//	
//	// --------------------------------------------------------------- ALWAYS CONVERT TO 24bit(1400uS) or 32bit(1200uS) 
//	g_BitsPixel = 32;
//
//	// --------------------------------------------------------------- BITMAPINFO
//    g_pBitmapInfo = (BITMAPINFO*) new BYTE [sizeof(BITMAPINFOHEADER)]; 
//
//	// --------------------------------------------------------------- BITMAPINFOHEADER
//	g_pBitmapInfo->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
//	g_pBitmapInfo->bmiHeader.biWidth = g_Width;
//	g_pBitmapInfo->bmiHeader.biHeight = g_Height;
//	g_pBitmapInfo->bmiHeader.biPlanes = 1;
//	g_pBitmapInfo->bmiHeader.biBitCount = (WORD)g_BitsPixel;
//	g_pBitmapInfo->bmiHeader.biCompression = BI_RGB;
//	g_pBitmapInfo->bmiHeader.biSizeImage = 0;
//	g_pBitmapInfo->bmiHeader.biXPelsPerMeter = 0;
//	g_pBitmapInfo->bmiHeader.biYPelsPerMeter = 0;
//	g_pBitmapInfo->bmiHeader.biClrUsed = 0;
//	g_pBitmapInfo->bmiHeader.biClrImportant = 0;
//
//
//	// --------------------------------------------------------------- CreateDIBSection usa le informazioni di BITMAPINFO 
//	//                                                                 e alloca la memoria per i bits della bitmap 
//	g_Bmp = CreateDIBSection(NULL, g_pBitmapInfo, DIB_RGB_COLORS, &g_Bits, NULL, NULL);
//
//
//	// --------------------------------------------------------------- Creo un DC in memoria per TextOut e Scroll
//	g_hdc = CreateCompatibleDC(NULL);
//	g_oldBmp = (HBITMAP) SelectObject(g_hdc, g_Bmp);
//
//
//	// --------------------------------------------------------------- Recupero "WidthBytes"
//	GetObject(g_Bmp, sizeof(BITMAP), &bmp);
//	g_WidthBytes = bmp.bmWidthBytes;
//	DeleteObject(&bmp);
//
//
//	// ----------------------------------------------------------- prendo i bits
//	GetDIBits( 
//				g_hdc, 
//				pBmp->operator HBITMAP(), 
//				0, 
//				g_Height, 
//				g_Bits, 
//				g_pBitmapInfo, 
//				DIB_RGB_COLORS
//			  );
//	// ============================================================================================
//
//}
//
/////////////////////////////////////////////////////////////////////////////////////
////  PIXEL / FILL / LINES / RECTANGLES / CIRCLES / SCROLL / TEXT ....
/////////////////////////////////////////////////////////////////////////////////////
//
//void BMP_SetPixel(
//											long x,
//											long y,
//											long Color
//										   )
//{
//	if (g_Bits == 0) return;
//
//	y = g_Height - y;
//
//	static BYTE* i;
//	
//	if (x >= 0 && y >= 0 && x < g_Width && y < g_Height)
//	{
//		if (g_BitsPixel == 8)
//		{
//			i = (BYTE*) g_Bits + x + y * g_WidthBytes;
//			*i = (BYTE)Color;
//		}
//
//		if (g_BitsPixel == 24)
//		{
//			i = (BYTE*) g_Bits + x * 3 + y * g_WidthBytes;
//		 	*i++ = (BYTE) (Color >> 16);
//			*i++ = (BYTE) (Color >> 8);
//			*i = (BYTE) Color;
//		}
//
//		if (g_BitsPixel == 32)
//		{
//			i = (BYTE*) g_Bits + x * 4 + y * g_WidthBytes;
//			//*i++ = (BYTE) (255);
//		 	*i++ = (BYTE) (Color >> 16);
//			*i++ = (BYTE) (Color >> 8);
//			*i = (BYTE) Color;
//		}
//	}
//}
//
//
//
//long BMP_GetPixel(
//											long x,
//											long y
//										   )
//{
//	if (g_Bits == 0) return 0;
//
//	y = g_Height - y;
//
//	static BYTE* i;
//	
//	if (x >= 0 && y >= 0 && x < g_Width && y < g_Height)
//	{
//		if (g_BitsPixel == 8)
//		{
//			i = (BYTE*) g_Bits + x + y * g_WidthBytes;
//			return *i;
//		}
//
//		if (g_BitsPixel == 24)
//		{
//			i = (BYTE*) g_Bits + x * 3 + y * g_WidthBytes;
//			return (*(i) << 16) + (*(i+1) << 8) + *(i+2);
//		}
//
//		if (g_BitsPixel == 32)
//		{
//			i = (BYTE*) g_Bits + x * 4 + y * g_WidthBytes;
//			return (*(i) << 16) + (*(i+1) << 8) + *(i+2);
//		}
//	}
//	return 0;
//}
//
//
//
//
//
//

static COLORREF MixedColor(COLORREF Color1, COLORREF Color2, double k)
{
	int R1 = GetRValue(Color1);
	int G1 = GetGValue(Color1);
	int B1 = GetBValue(Color1);
	int R2 = GetRValue(Color2);
	int G2 = GetGValue(Color2);
	int B2 = GetBValue(Color2);
	return RGB(R1+int((R2-R1)*k), G1+int((G2-G1)*k), B1+int((B2-B1)*k));
}

//
//
//
//
//// 1200uS  ( BMP_InitFromHDC version ) (working with 16 and 32 bits per pixel )
//
//void AntialiasedCircleFilled(CDC *DC,
//						  double CenterX, 
//						  double CenterY, 
//						  double Radius, 
//						  double Feather, 
//						  COLORREF Color)
//{
//
//	//	return;
//
//	HDC hDC = DC->operator HDC();
//
//	BMP_InitFromHDC(hDC);
//
//
//	int x,y;
//	int LX, RX, LY, RY;
//	double RPF2, RMF2;
//    double SqY, SqDist, k;
//	// ------------------------------------------------------------ helpful values
//	RPF2 = Radius + Feather / 2;
//	RMF2 = Radius - Feather / 2;
//	//
//	RPF2 = RPF2 * RPF2;
//	RMF2 = RMF2 * RMF2;
//	// ------------------------------------------------------------ bounds
//	LX = int(floor(CenterX - Radius - Feather));
//	RX = int(ceil (CenterX + Radius + Feather));
//	LY = int(floor(CenterY - Radius - Feather));
//	RY = int(ceil (CenterY + Radius + Feather));
//	// ------------------------------------------------------------ scan all the area
//	for (y = LY; y <= RY; y++)
//	{
//		// -------------------------------------------------------- the squared distance from center for this pixel
//		SqY = y - CenterY;
//		SqY = SqY * SqY;
//		//
//		for (x = LX; x <= RX; x++)
//		{
//			// ---------------------------------------------------- the squared distance from center for this pixel
//			SqDist = SqY + (x - CenterX) * (x - CenterX);
//			//
//			if (SqDist < RMF2) // check if inside the inner circle
//			{
//				// ------------------------------------------------ in the inner area ( fill area )
//				//pDC->SetPixelV(x, y, Color);
//				BMP_SetPixel(x, y, Color);
//			}
//			else if (SqDist < RPF2) // check if inside the outer circle
//			{
//				// ------------------------------------------------ in the feather area
//				k = ( sqrt(SqDist) - (Radius - Feather / 2) ) / Feather;
//				//pDC->SetPixelV(x, y, MixedColor(Color, pDC->GetPixel(x, y), k));
//				BMP_SetPixel(x, y, MixedColor(Color, BMP_GetPixel(x, y), k));
//			}
//		}
//	}
//
//	
//	BMP_Show(hDC);
//
//	BMP_End();
//}
//
//
//void AntialiasedCircle(CDC *DC,
//						  double CenterX, 
//						  double CenterY, 
//						  double Radius,
//						  double LineWidth,
//						  double Feather, 
//						  COLORREF Color)
//{
//
//	HDC hDC = DC->operator HDC();
//
//	BMP_InitFromHDC(hDC);
//
//
//	int x,y;
//	int LX, RX, LY, RY;
//	double ROPF2, RO2, RI2, RIMF2;
//	double OutRad, InRad;
//    double SqY, SqDist, k;
//	// ------------------------------------------------------------  helpful values
//	OutRad = Radius + LineWidth / 2;
//	InRad  = Radius - LineWidth / 2;
//	//
//	ROPF2 = OutRad + Feather;
//	RO2 = OutRad;
//	RI2 = InRad;
//	RIMF2 = InRad  - Feather;
//	//
//	ROPF2 = ROPF2 * ROPF2;
//	RO2 = RO2 * RO2;
//	RI2 = RI2 * RI2;
//	RIMF2 = RIMF2 * RIMF2;
//	// ------------------------------------------------------------ bounds
//	LX = int(floor(CenterX - OutRad - Feather));
//	RX = int(ceil (CenterX + OutRad + Feather));
//	LY = int(floor(CenterY - OutRad - Feather));
//	RY = int(ceil (CenterY + OutRad + Feather));
//	// ------------------------------------------------------------ scan all the area
//	for (y = LY; y <= RY; y++)
//	{
//		// -------------------------------------------------------- squared distance from center for this pixel
//		SqY = y - CenterY;
//		SqY = SqY * SqY;
//		//
//		for (x = LX; x <= RX; x++)
//		{
//			// ---------------------------------------------------- squared distance from center for this pixel
//			SqDist = SqY + (x - CenterX) * (x - CenterX);
//
//			if (SqDist >= RIMF2) // check if not completely inside (most often)
//			{
//				if (SqDist < ROPF2) // check if not completely outside
//				{
//					if (SqDist >= RO2)
//					{
//						// --------------------------------------------------- in the outer feather area
//						k = ( sqrt(SqDist) - OutRad ) / Feather;
//						//pDC->SetPixel(x, y, MixedColor(Color, pDC->GetPixel(x, y), k));
//						BMP_SetPixel(x, y, MixedColor(Color, BMP_GetPixel(x, y), k));
//					}
//					else
//					{
//						if (SqDist < RI2)
//						{
//							// ------------------------------------------------ in the inner feather area
//							k = ( InRad - sqrt(SqDist) ) / Feather;
//							//pDC->SetPixel(x, y, MixedColor(Color, pDC->GetPixel(x, y), k));
//							BMP_SetPixel(x, y, MixedColor(Color, BMP_GetPixel(x, y), k));
//						}
//						else
//						{
//							// ------------------------------------------------ on the line
//							//pDC->SetPixel(x, y, Color);
//							BMP_SetPixel(x, y, Color);
//						}
//					}
//				}
//			}
//		}
//	}
//
//	
//	BMP_Show(hDC);
//
//	BMP_End();
//}





static void AntialiasedCircle(CDC* pDC, 
					   double CenterX, 
					   double CenterY, 
					   double Radius, 
					   double LineWidth, 
					   double Feather, 
					   COLORREF Color)
{
	int x,y;
	int LX, RX, LY, RY;
	double ROPF2, RO2, RI2, RIMF2;
	double OutRad, InRad;
    double SqY, SqDist, k;
	// ------------------------------------------------------------  helpful values
	OutRad = Radius + LineWidth / 2;
	InRad  = Radius - LineWidth / 2;
	//
	ROPF2 = OutRad + Feather;
	RO2 = OutRad;
	RI2 = InRad;
	RIMF2 = InRad  - Feather;
	//
	ROPF2 = ROPF2 * ROPF2;
	RO2 = RO2 * RO2;
	RI2 = RI2 * RI2;
	RIMF2 = RIMF2 * RIMF2;
	// ------------------------------------------------------------ bounds
	LX = int(floor(CenterX - OutRad - Feather));
	RX = int(ceil (CenterX + OutRad + Feather));
	LY = int(floor(CenterY - OutRad - Feather));
	RY = int(ceil (CenterY + OutRad + Feather));
	// ------------------------------------------------------------ scan all the area
	for (y = LY; y <= RY; y++)
	{
		// -------------------------------------------------------- squared distance from center for this pixel
		SqY = y - CenterY;
		SqY = SqY * SqY;
		//
		for (x = LX; x <= RX; x++)
		{
			// ---------------------------------------------------- squared distance from center for this pixel
			SqDist = SqY + (x - CenterX) * (x - CenterX);

			if (SqDist >= RIMF2) // check if not completely inside (most often)
			{
				if (SqDist < ROPF2) // check if not completely outside
				{
					if (SqDist >= RO2)
					{
						// --------------------------------------------------- in the outer feather area
						k = ( sqrt(SqDist) - OutRad ) / Feather;
						pDC->SetPixel(x, y, MixedColor(Color, pDC->GetPixel(x, y), k));
					}
					else
					{
						if (SqDist < RI2)
						{
							// ------------------------------------------------ in the inner feather area
							k = ( InRad - sqrt(SqDist) ) / Feather;
							pDC->SetPixel(x, y, MixedColor(Color, pDC->GetPixel(x, y), k));
						}
						else
						{
							// ------------------------------------------------ on the line
							pDC->SetPixel(x, y, Color);
						}
					}
				}
			}
		}
	}
}




static void AntialiasedCircleFilled(CDC* pDC, 
							 double CenterX, 
							 double CenterY, 
							 double Radius, 
							 double Feather, 
							 COLORREF Color)
{
	int x,y;
	int LX, RX, LY, RY;
	double RPF2, RMF2;
    double SqY, SqDist, k;
	// ------------------------------------------------------------ helpful values
	RPF2 = Radius + Feather / 2;
	RMF2 = Radius - Feather / 2;
	//
	RMF2 = RMF2 * RMF2;
	RPF2 = RPF2 * RPF2;
	// ------------------------------------------------------------ bounds
	LX = int(floor(CenterX - Radius));
	RX = int(ceil(CenterX + Radius));
	LY = int(floor(CenterY - Radius));
	RY = int(ceil(CenterY + Radius));
	// ------------------------------------------------------------ scan all the area
	for (y = LY; y <= RY; y++)
	{
		// -------------------------------------------------------- the squared distance from center for this pixel
		SqY = y - CenterY;
		SqY = SqY * SqY;
		//
		for (x = LX; x <= RX; x++)
		{
			// ---------------------------------------------------- the squared distance from center for this pixel
			SqDist = SqY + (x - CenterX) * (x - CenterX);
			//
			if (SqDist < RMF2) // check if inside the inner circle
			{
				// ------------------------------------------------ in the inner area ( fill area )
				pDC->SetPixel(x, y, Color);
			}
			else if (SqDist < RPF2) // check if inside the outer circle
			{
				// ------------------------------------------------ in the feather area
				k = ( sqrt(SqDist) - (Radius - Feather / 2) ) / Feather;
				pDC->SetPixel(x, y, MixedColor(Color, pDC->GetPixel(x, y), k));
			}
		}
	}
}


#endif